<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\BranchRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Branch;
use App\BranchDetail;
use App\Specialty;
use App\WorkDay;
use App\Reservation;
use App\DoctorReservation;
use Illuminate\Support\Facades\DB;

class BranchController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/branches';
    /** View folder */
    private $viewDirectory= 'admin.branches.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('branches.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the branches.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Branch::orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $branches= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('branches'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('branches.store');
        $head = metaFields('branches', 'add_new', getCurrentLocale()) ?? __('branches.new');
        $specialties = Specialty::all();
       

        return view( $this->viewDirectory.'form', compact('action', 'head','specialties') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param BranchRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(BranchRequest $request) :RedirectResponse
    {
     
        $branch= Branch::create($request->except(['details','specialties']));
        $branch->specialties()->attach($request->specialty_id);
        if(!is_null($request->details))
        {
        foreach($request->details as $row)
        {
        BranchDetail::create([
            'branch_id'=>$branch->id,
            'key'=>$row['key'],
            'value'=>$row['value'],
            'details'=>$row['details']
            ]);
        }
        }
        if(!is_null($request->day))
        {
        foreach($request->day as $row)
        {
        WorkDay::create([
            'branch_id'=>$branch->id,
            'day'=>$row['day'],
            'start'=>$row['start'],
            'end'=>$row['end']
            ]);
        }
        }
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Branch  $branch
     * @return View
     */
    public function edit(Branch $branch): View
    {
        $action= route('branches.update', $branch->id);
        $head = metaFields('branches', 'edit', getCurrentLocale()) ?? __('branches.edit');
        $specialties = Specialty::all();
        $branchdetails = BranchDetail::where('branch_id',$branch->id)->get();
        $daywork = WorkDay::where('branch_id',$branch->id)->get();
        
        
        
        $allreservations= DoctorReservation::count();
        
        
        $difDays = date('d');
        $difMonths = date('n');
        $difDays = 30 - $difDays . ' day';
        $difMonths = 12 - $difMonths . ' month';

        $lastYear = date("Y-m-d", strtotime("-1 year $difMonths $difDays"));
        $nextYear = date("Y-m-d", strtotime("0 year $difMonths $difDays"));

        
        $toDay = date("Y-m-d");
        $days = [];

        $ids = Reservation::where('branch_id',$branch->id)->pluck('id');
        
        $websiteVisitors = DB::table('doctor_reservation_details')
            ->whereIn('doctor_reservation_id',$ids)
            ->orderBy('dating', 'asc')
            ->whereBetween('dating', [$lastYear, $nextYear])
            ->pluck('dating')->toArray();

        

        foreach ($websiteVisitors as $key => $websiteVisitor) {
            $websiteVisitors[$key] = date('n', strtotime($websiteVisitor));
            $days[] = date('Y-m-d', strtotime($websiteVisitor));
        }
        
        $monthVisitCounts = array_count_values($websiteVisitors);
        
        
        
        
        

        return view( $this->viewDirectory.'form', compact('branch', 'allreservations','monthVisitCounts','action', 'head','specialties','branchdetails','daywork') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  BranchRequest  $request
     * @param  Branch  $branch
     * @return RedirectResponse|Redirector
     */
    public function update(BranchRequest $request, Branch $branch) :RedirectResponse
    {
      
        $branch->update($request->except(['details','specialties','day']));
		$branch->specialties()->sync($request->specialty_id);
		 if(!is_null($request->details))
        {
            $branches = BranchDetail::where('branch_id',$branch->id)->forceDelete();
            
            
        foreach($request->details as $row)
        {
        BranchDetail::create([
            'branch_id'=>$branch->id,
            'key'=>$row['key'],
            'value'=>$row['value'],
            'details'=>$row['details']
            ]);
        }
        }
         if(!is_null($request->day))
        {
            $days = WorkDay::where('branch_id',$branch->id)->forceDelete();
        foreach($request->day as $row)
        {
        WorkDay::create([
            'branch_id'=>$branch->id,
            'day'=>$row['day'],
            'start'=>$row['start'],
            'end'=>$row['end']
            ]);
        }
        }

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = Branch::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Branch::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Branch::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = Branch::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = Branch::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
